#include "slimawt.h"
#include <windowsx.h>
#include <string.h>
#include "htable.h"
#include <stdlib.h>
#include <time.h>
#include <sys/timeb.h>
#include <commdlg.h>
#include <winuser.h>

extern cptr hInstance;
extern cint nCmdShow;
extern cptr boolean_True, boolean_False, object_Undefined;
extern cint manage_event_ID;

BOOL send_setVisible = TRUE,
     sizing = FALSE;
//     created_frame_before = FALSE; //Why does windows send 2 move messages for first frame
UINT send_Move = 0,
     send_setSize = 0;

WNDCLASS frame_class, dialog_class, panel_class, window_class;

char filter[] = "All Files (*.*)\0*.*\0";

HWND currenthwnd = NULL, sizinghwnd=NULL;

UINT modaldialogsrunning = 0;

hash_table action_listener_hash_table       = {0, 0, 0, 0, NULL},
           adjustment_listener_hash_table   = {0, 0, 0, 0, NULL},
           component_listener_hash_table    = {0, 0, 0, 0, NULL},
           focus_listener_hash_table        = {0, 0, 0, 0, NULL},
           item_listener_hash_table         = {0, 0, 0, 0, NULL},
           key_listener_hash_table          = {0, 0, 0, 0, NULL},
           mouse_listener_hash_table        = {0, 0, 0, 0, NULL},
           mouse_motion_listener_hash_table = {0, 0, 0, 0, NULL},
           text_listener_hash_table         = {0, 0, 0, 0, NULL},
           window_listener_hash_table       = {0, 0, 0, 0, NULL},
           maximized_hash_table             = {0, 0, 0, 0, NULL};

WNDPROC DefButtonProc, DefCheckboxProc, DefChoiceProc, DefListProc, 
        DefScrollbarProc, DefEditProc, DefLabelProc, DefTextProc, 
        DefListProc, proc_to_run;

HCURSOR default_cursor, crosshair_cursor, text_cursor, wait_cursor, 
        sw_resize_cursor, se_resize_cursor, nw_resize_cursor, ne_resize_cursor,
        n_resize_cursor, s_resize_cursor, w_resize_cursor, e_resize_cursor, 
        hand_cursor, move_cursor; 

UINT click_delay, button_count = 0;

BOOL lbutton_down = FALSE, mbutton_down = FALSE, rbutton_down = FALSE, moving = FALSE,
     process_lbutton = TRUE, process_mbutton = TRUE, process_rbutton = TRUE;
     send_click = TRUE;

HBRUSH brush = NULL;
int fRed, fGreen, fBlue, bRed, bGreen, bBlue;

int last_x, last_y;

double last_button = 0.0;

cptr *FontList=NULL;
int tempcounter;
HHOOK MouseHook;
BOOL awt_initialize()
{
  //Load the cursors;
  default_cursor = LoadCursor(NULL, IDC_ARROW);
  crosshair_cursor = LoadCursor(NULL, IDC_CROSS);
  text_cursor = LoadCursor(NULL, IDC_IBEAM);
  wait_cursor = LoadCursor(NULL, IDC_WAIT);
  sw_resize_cursor = LoadCursor(NULL, IDC_SIZENESW);
  se_resize_cursor = LoadCursor(NULL, IDC_SIZENWSE);
  nw_resize_cursor = se_resize_cursor;
  ne_resize_cursor = sw_resize_cursor;
  n_resize_cursor = LoadCursor(NULL, IDC_SIZENS);
  s_resize_cursor = n_resize_cursor;
  w_resize_cursor = LoadCursor(NULL, IDC_SIZEWE);
  e_resize_cursor = w_resize_cursor;
//  hand_cursor = (HCURSOR) LoadImage(NULL, 32513, IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE);
  hand_cursor = LoadCursor(NULL, IDC_ARROW);
  move_cursor = LoadCursor(NULL, IDC_ARROW); //check these

  frame_class.style = 0;
  frame_class.lpfnWndProc = WndProc;
  frame_class.cbClsExtra = 0;
  frame_class.cbWndExtra = 0;
  frame_class.hInstance = hInstance;
  frame_class.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  frame_class.hCursor = default_cursor;
  frame_class.hbrBackground = GetStockObject(WHITE_BRUSH);
  frame_class.lpszMenuName = NULL;
  frame_class.lpszClassName = "Slim Frame";

  if (!RegisterClass(&frame_class))
    return FALSE;

  dialog_class.style = 0;
  dialog_class.lpfnWndProc = WndProc;
  dialog_class.cbClsExtra = 0;
  dialog_class.cbWndExtra = 0;
  dialog_class.hInstance = hInstance;
  dialog_class.hIcon = NULL;
  dialog_class.hCursor = default_cursor;
  dialog_class.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_3DFACE)); //GetStockObject(LTGRAY_BRUSH);
  dialog_class.lpszMenuName = NULL;
  dialog_class.lpszClassName = "Slim Dialog";

  if (!RegisterClass(&dialog_class))
    return FALSE;

  panel_class.style = 0;
  panel_class.lpfnWndProc = PanelProc;
  panel_class.cbClsExtra = 0;
  panel_class.cbWndExtra = 0;
  panel_class.hInstance = hInstance;
  panel_class.hIcon = NULL;
  panel_class.hCursor = default_cursor;
  panel_class.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_3DFACE)); 
  panel_class.lpszMenuName = NULL;
  panel_class.lpszClassName = "Slim Panel";

  if (!RegisterClass(&panel_class))
    return FALSE;

  window_class.style = 0;
  window_class.lpfnWndProc = WndProc;
  window_class.cbClsExtra = 0;
  window_class.cbWndExtra = 0;
  window_class.hInstance = hInstance;
  window_class.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  window_class.hCursor = default_cursor;
  window_class.hbrBackground = GetStockObject(WHITE_BRUSH);
  window_class.lpszMenuName = NULL;
  window_class.lpszClassName = "Slim Window";

  if (!RegisterClass(&window_class))
    return FALSE;

  proc_to_run = DefWindowProc;
  MouseHook = SetWindowsHookEx(WH_MOUSE, MouseProc, (HINSTANCE) NULL,GetCurrentThreadId());
  click_delay = GetDoubleClickTime();
  return TRUE;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefWindowProc;

  switch (Message)
  {
    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnDFSize);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_ACTIVATE, OnGotFocus);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    HANDLE_MSG(hwnd, WM_CLOSE, OnClose);
    HANDLE_MSG(hwnd, WM_VSCROLL, OnVScroll);
    HANDLE_MSG(hwnd, WM_HSCROLL, OnHScroll);
    HANDLE_MSG(hwnd, WM_SETCURSOR, OnSetCursor);
    HANDLE_MSG(hwnd, WM_CTLCOLORBTN, OnCtlColorBtn);
    HANDLE_MSG(hwnd, WM_CTLCOLORSTATIC, OnCtlColorStatic);
    HANDLE_MSG(hwnd, WM_CTLCOLOREDIT, OnCtlColorEdit);
    HANDLE_MSG(hwnd, WM_CTLCOLORSCROLLBAR, OnCtlColorScrollbar);
    HANDLE_MSG(hwnd, WM_CTLCOLORLISTBOX, OnCtlColorListbox);
    case WM_CAPTURECHANGED : OnCaptureChanged(hwnd, (HWND) lParam);
                             return 0;
    default:
      return DefWindowProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK PanelProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefWindowProc;

  switch (Message)
  {
    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_ACTIVATE, OnGotFocus);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    HANDLE_MSG(hwnd, WM_CLOSE, OnClose);
    HANDLE_MSG(hwnd, WM_VSCROLL, OnVScroll);
    HANDLE_MSG(hwnd, WM_HSCROLL, OnHScroll);
    HANDLE_MSG(hwnd, WM_SETCURSOR, OnSetCursor);
    HANDLE_MSG(hwnd, WM_CTLCOLORBTN, OnCtlColorBtn);
    HANDLE_MSG(hwnd, WM_CTLCOLORSTATIC, OnCtlColorStatic);
    HANDLE_MSG(hwnd, WM_CTLCOLOREDIT, OnCtlColorEdit);
    HANDLE_MSG(hwnd, WM_CTLCOLORSCROLLBAR, OnCtlColorScrollbar);
    HANDLE_MSG(hwnd, WM_CTLCOLORLISTBOX, OnCtlColorListbox);
    case WM_CAPTURECHANGED : OnCaptureChanged(hwnd, (HWND) lParam);
                             return 0;
    default:
      return DefWindowProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK ButtonProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefButtonProc;

  switch (Message)
  {
//    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    default:
      return DefButtonProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK CheckboxProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefCheckboxProc;

  switch (Message)
  {
    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    default:
      return DefCheckboxProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK ChoiceProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefChoiceProc;
  switch (Message)
  {
//    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    HANDLE_MSG(hwnd, WM_CTLCOLORLISTBOX, OnCtlColorChoiceListbox);
    default:
      return DefChoiceProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK LabelProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefLabelProc;
  switch (Message)
  {
    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    default:
      return DefLabelProc(hwnd, Message, wParam, lParam);
  }
}

void OnPaste(HWND hwnd)
{
  return;
}

LRESULT CALLBACK TextProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefTextProc;
  switch (Message)
  {
//    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    HANDLE_MSG(hwnd, WM_PASTE, OnPaste);
    default:
      return DefTextProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK ScrollbarProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefScrollbarProc;

  switch (Message)
  {
//    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    default:
      return DefScrollbarProc(hwnd, Message, wParam, lParam);
  }
}

LRESULT CALLBACK ListProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
  proc_to_run = DefListProc;

  switch (Message)
  {
//    HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
    HANDLE_MSG(hwnd, WM_MOVE, OnMove);
    HANDLE_MSG(hwnd, WM_SIZE, OnSize);
    HANDLE_MSG(hwnd, WM_KEYDOWN, OnKey);
    HANDLE_MSG(hwnd, WM_KEYUP, OnKey);
    HANDLE_MSG(hwnd, WM_SYSKEYDOWN, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SYSKEYUP, OnSystemKey);
    HANDLE_MSG(hwnd, WM_SHOWWINDOW, OnShowWindow);
    HANDLE_MSG(hwnd, WM_LBUTTONDOWN, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_LBUTTONUP, OnLButtonUp);
    HANDLE_MSG(hwnd, WM_MBUTTONDOWN, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONUP, OnMButtonUp);
    HANDLE_MSG(hwnd, WM_RBUTTONDOWN, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONUP, OnRButtonUp);
    HANDLE_MSG(hwnd, WM_LBUTTONDBLCLK, OnLButtonDown);
    HANDLE_MSG(hwnd, WM_MBUTTONDBLCLK, OnMButtonDown);
    HANDLE_MSG(hwnd, WM_RBUTTONDBLCLK, OnRButtonDown);
    HANDLE_MSG(hwnd, WM_MOUSEMOVE, OnMouseMove);
    HANDLE_MSG(hwnd, WM_SETFOCUS, OnSetFocus);
    HANDLE_MSG(hwnd, WM_KILLFOCUS, OnKillFocus);
    default:
      return DefListProc(hwnd, Message, wParam, lParam);
  }
}

void OnCommand(HWND hwnd, int ID, HWND hwndCtl, UINT codeNotify)
{
  cptr source;

  if (codeNotify == LBN_DBLCLK)
  {
    source = lookup_value_using_hash_table(&action_listener_hash_table, hwndCtl);

    if (source)
    {
      cptr event_type = object_integer_from(128), //AWTEvent.ACTION_EVENT_MASK
           id = object_integer_from(1001), //ActionEvent.ACTION_PERFORMED
           command,
           modifiers,
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
      UINT flags = 0;
      int index = ListBox_GetCurSel(hwndCtl),
          strlength = ListBox_GetTextLen(hwndCtl, index);
      char *string;

      string = mem_malloc(strlength+1);
      ListBox_GetText(hwndCtl, index, string);
      command = object_string_from(string);
    
      if (GetAsyncKeyState(VK_CONTROL) != 0)
         flags |=  2;
      if (GetAsyncKeyState(VK_SHIFT) != 0)
        flags |=  1;
      if (GetAsyncKeyState(VK_MENU) != 0)
        flags |=  8;
   
      modifiers = object_integer_from(flags);
      {   
         cint array_of_params[] = {source, event_type, id, command, modifiers, 0};
   
         source[1] += 1;
         ((cint*)procedure)[1] += 1;
         procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
  }
  else if (codeNotify == LBN_SELCHANGE && (GetWindowLong(hwndCtl, GWL_STYLE) & LBS_WANTKEYBOARDINPUT)) //have to be able to different from combo box somehow!!
  {
    source = lookup_value_using_hash_table(&item_listener_hash_table, hwndCtl);

    if (source)
    {
      BOOL selected = ListBox_GetSel(hwndCtl, ListBox_GetCurSel(hwndCtl)) ? 1 : 2; //Determines if item is selected or not
      cptr event_type = object_integer_from(512), //AWTEvent.ITEM_EVENT_MASK
           id = object_integer_from(701), //ItemEvent.ITEM_STATE_CHANGED
           item,
           statechange = object_integer_from(selected), //ItemEvent.SELECTED or ItemEvent.DESELECTED
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 6);
      int index = ListBox_GetCurSel(hwndCtl),
          strlength = ListBox_GetTextLen(hwndCtl, index);
      char *string;

      string = mem_malloc(strlength+1);
      ListBox_GetText(hwndCtl, index, string);
      item = object_string_from(string);
  
      {   
        cint array_of_params[] = {source, event_type, id, item, statechange, object_integer_from(index), 0};
   
        source[1] += 1;
        ((cint*)procedure)[1] += 1;
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
  }
  else if (codeNotify == CBN_SELCHANGE) //Checkbox selection change
  {
    source = lookup_value_using_hash_table(&item_listener_hash_table, hwndCtl);
    if (source)
    {
      cptr event_type = object_integer_from(512), //AWTEvent.ITEM_EVENT_MASK
           id = object_integer_from(701), //ItemEvent.ITEM_STATE_CHANGED
           item,
           statechange = object_integer_from(1), //ItemEvent.SELECTED
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 6);
      int index = ComboBox_GetCurSel(hwndCtl),
          strlength = ComboBox_GetLBTextLen(hwndCtl, index);
      char *string;

      string = mem_malloc(strlength+1);
      ComboBox_GetLBText(hwndCtl, index, string);
      item = object_string_from(string);
  
      {   
        cint array_of_params[] = {source, event_type, id, item, statechange, object_integer_from(index), 0};
   
        source[1] += 1;
        ((cint*)procedure)[1] += 1;
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
  }
  else if (codeNotify == BN_CLICKED) //button clicked e.g. checkbox or radio button
  {
    if (hwndCtl == 0)
    {
        source = lookup_value_using_hash_table(&action_listener_hash_table, ID);

        if (source)
        {
          cptr event_type = object_integer_from(128), //AWTEvent.ACTION_EVENT_MASK
               id = object_integer_from(1001), //ActionEvent.ACTION_PERFORMED
               modifiers,
               procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 4);
               UINT flags = 0;
    
          if (GetAsyncKeyState(VK_CONTROL) != 0)
            flags |=  2;
          if (GetAsyncKeyState(VK_SHIFT) != 0)
            flags |=  1;
          if (GetAsyncKeyState(VK_MENU) != 0)
            flags |=  8;
   
          modifiers = object_integer_from(flags);
          {   
            cint array_of_params[] = {source, event_type, id, modifiers, 0};
      
            source[1] += 1;
            ((cint*)procedure)[1] += 1;
            procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
          }
        }
    }
    //Have to do it this way, because the values of BS_PUSHBUTTON is 0
    else if (!(GetWindowLong(hwndCtl, GWL_STYLE) & BS_AUTOCHECKBOX)) //If it is a push button
    {
      source = lookup_value_using_hash_table(&action_listener_hash_table, (hwndCtl != NULL) ? hwndCtl : ID);
      if (source)
      {
        cptr event_type = object_integer_from(128),
             id = object_integer_from(1001),
             modifiers,
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 4);
        UINT flags = 0;
    
        if (GetAsyncKeyState(VK_CONTROL) != 0)
          flags |=  2;
        if (GetAsyncKeyState(VK_SHIFT) != 0)
          flags |=  1;
        if (GetAsyncKeyState(VK_MENU) != 0)
          flags |=  8;
   
        modifiers = object_integer_from(flags);
        {   
          cint array_of_params[] = {source, event_type, id, modifiers, 0};
     
          source[1] += 1;
          ((cint*)procedure)[1] += 1;
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    }
    else //it is a checkbox or radio button
    {
      source = lookup_value_using_hash_table(&item_listener_hash_table, hwndCtl);
      if (source)
      {
        cptr event_type = object_integer_from(512), //AWTEvent.ITEM_EVENT_MASK
             id = object_integer_from(701), //ItemEvent.ITEM_STATE_CHANGED
             statechange = object_integer_from(Button_GetCheck(hwndCtl) ? 1 : 2), //ItemEvent.SELECTED
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 4);
        {   
          cint array_of_params[] = {source, event_type, id, statechange, 0};
     
          source[1] += 1;
          ((cint*)procedure)[1] += 1;
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    }
  }
  else if (codeNotify == EN_CHANGE) //text value changed
  {
    source = lookup_value_using_hash_table(&text_listener_hash_table, hwndCtl);

    if (source)
    {
      cptr event_type = object_integer_from(1024), //AWTEvent.TEXT_EVENT_MASK
           id = object_integer_from(900), //TextEvent.TEXT_VALUE_CHANGED
//           string = get_text(source), //new value of edit control
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
      {   
        cint array_of_params[] = {source, event_type, id, 0};
   
        source[1] += 1;
        ((cint*)procedure)[1] += 1;
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
  }
  FORWARD_WM_COMMAND(hwnd, ID, hwndCtl, codeNotify, proc_to_run);
}

void OnPaint(HWND hwnd)
{
  FORWARD_WM_PAINT(hwnd, proc_to_run);
}

void OnMove(HWND hwnd, int x, int y)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
//printf("%d moving %d\n", hwnd, send_Move);
  if (source && send_Move == 0)
  {
    cptr event_type = object_integer_from(1),
         id = object_integer_from(100),
         x_pos,
         y_pos,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
    RECT r;
  
    GetWindowRect(hwnd, &r);
    x_pos = object_integer_from(r.left);
    y_pos = object_integer_from(r.top);
    {
      cint array_of_params[] = {source, event_type, id, x_pos, y_pos, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  else
    FORWARD_WM_MOVE(hwnd, x, y, proc_to_run);
  if (send_Move != 0)
    send_Move--;
}

void OnDFSize(HWND hwnd, UINT nType, int cx, int cy)
{
  if (!(nType == SIZE_MAXIMIZED) && (!lookup_value_using_hash_table(&maximized_hash_table, hwnd)))
  {
    if ((send_setSize == 0) || (GetCapture() == hwnd))
      sizing = TRUE;
    else
      send_setSize--;
  }
  else
  {
    cptr source;

    if (lookup_value_using_hash_table(&maximized_hash_table, hwnd))
      remove_from_hash_table(&maximized_hash_table, hwnd);
    else
      add_to_hash_table(&maximized_hash_table, hwnd, TRUE); 

    source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
    if (source)
    {
      cptr event_type = object_integer_from(1),
           id = object_integer_from(101),
           width,
           height, 
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
      RECT r;
      GetWindowRect(hwnd, &r);
      width = object_integer_from(r.right - r.left);
      height = object_integer_from(r.bottom - r.top);
      {
        cint array_of_params[] = {source, event_type, id, width, height, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      InvalidateRect(hwnd, NULL, TRUE); 
    }
    else
      FORWARD_WM_SIZE(hwnd, nType, cx, cy, proc_to_run);
    if (send_setSize != 0)
      send_setSize--;
  }
  
  FORWARD_WM_SIZE(hwnd, nType, cx, cy, proc_to_run);
}

void OnSize(HWND hwnd, UINT nType, int cx, int cy)
{
  cptr source;

  source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
//printf("%d moving %d\n", hwnd, send_setSize);
  if (source && send_setSize == 0)
  {
    cptr event_type = object_integer_from(1),
         id = object_integer_from(101),
         width,
         height, 
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
    RECT r;
    GetWindowRect(hwnd, &r);
    width = object_integer_from(r.right - r.left);
    height = object_integer_from(r.bottom - r.top);
    {
      cint array_of_params[] = {source, event_type, id, width, height, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    InvalidateRect(hwnd, NULL, TRUE); 
  }
  else
    FORWARD_WM_SIZE(hwnd, nType, cx, cy, proc_to_run);
  if (send_setSize != 0)
    send_setSize--;
}

void OnShowWindow(HWND hwnd, BOOL bShow, UINT nStatus)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);

  if (source && send_setVisible)
  {
    cptr event_type = object_integer_from(1),
         id = (bShow ? object_integer_from(102) : object_integer_from(103)),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    cint array_of_params[] = {source, event_type, id, 0};

    source[1] += 1;
    ((cint*)procedure)[1] += 1;      
    procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
  }
  else
    FORWARD_WM_SHOWWINDOW(hwnd, bShow, nStatus, proc_to_run);
  send_setVisible = TRUE;
}

void OnCaptureChanged(HWND hwnd, HWND other_hwnd)
{

  if (sizing)
  {
    cptr source;
    source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);

    if (source) //&& send_setSize == 0)
    {
      cptr event_type = object_integer_from(1),
           id = object_integer_from(101),
           width,
           height, 
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
      RECT r;
      GetWindowRect(hwnd, &r);
      width = object_integer_from(r.right - r.left);
      height = object_integer_from(r.bottom - r.top);
      {
        cint array_of_params[] = {source, event_type, id, width, height, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      InvalidateRect(hwnd, NULL, TRUE); 
    }
    sizing = FALSE;
    send_setSize = 0;
  }
}

UINT convert_key(UINT nVirtKey)
{
  UINT vkChar;
  BOOL Shift = GetAsyncKeyState(VK_SHIFT) != 0,
       Ctrl = GetAsyncKeyState(VK_CONTROL) != 0,
       CapsLock = GetKeyState(VK_CAPITAL) != 0;
  
  vkChar = MapVirtualKey(nVirtKey, 2);
  if (vkChar >= 'A' && vkChar <= 'Z')
  {
    if (Ctrl)
      return vkChar - 'A' + 1;
    if ((CapsLock && Shift) || (!CapsLock && !Shift))
      return 'a' + vkChar - 'A';
    return vkChar;
  }
  if (Shift)
    switch (vkChar) {
      case '`'  : return '~';
      case '1'  : return '!';
      case '2'  : return '@';
      case '3'  : return '#';
      case '4'  : return '$';
      case '5'  : return '%';
      case '6'  : return '^';
      case '7'  : return '&';
      case '8'  : return '*';
      case '9'  : return '(';
      case '0'  : return ')';
      case '-'  : return '_';
      case '='  : return '+';
      case '['  : return '{';
      case ']'  : return '}';
      case ';'  : return ':';
      case '\'' : return '"';
      case ','  : return '<';
      case '.'  : return '>';
      case '/'  : return '?';
      case '\\' : return '|';
    }
  if (vkChar == 13)
    return 10;
  return vkChar;
}

UINT key_code(UINT nVirtKey)
{
  switch (nVirtKey)
  {
    case VK_INSERT   : return 155;
    case VK_DELETE   : return 127;
    case VK_SNAPSHOT : return 154;
    case VK_RETURN   : return 10;
  }
  return nVirtKey;
}

void OnKey(HWND hwnd, UINT nVirtKey, BOOL fDown, int cRepeat, UINT nFlags)
{
  if (!fDown && nVirtKey == VK_RETURN && sizing)
  {
    cptr source;
  
    source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
    if (source && send_setSize == 0)
    {
      cptr event_type = object_integer_from(1),
           id = object_integer_from(101),
           width,
           height, 
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
      RECT r;
      GetWindowRect(hwnd, &r);
      width = object_integer_from(r.right - r.left);
      height = object_integer_from(r.bottom - r.top);
      {
        cint array_of_params[] = {source, event_type, id, width, height, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      InvalidateRect(hwnd, NULL, TRUE); 
    }
    sizing = FALSE;
    send_setSize = 0;
  }
  if (fDown)
  {
    cptr source;
  
    source = lookup_value_using_hash_table(&key_listener_hash_table, hwnd);

    if (source)
    {
      cptr event_type = object_integer_from(8),
           id = object_integer_from(401),
           when = object_number_from((float) get_time()),
           modifiers,
           keyCode = object_integer_from(key_code(nVirtKey)),
           keyChar = object_integer_from(convert_key(nVirtKey)),
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
      UINT flags = 0;

      if (GetAsyncKeyState(VK_CONTROL) != 0)
        flags |=  2;
      if (GetAsyncKeyState(VK_SHIFT) != 0)
        flags |=  1;
      if (GetAsyncKeyState(VK_MENU) != 0)
        flags |=  8;

      modifiers = object_integer_from(flags);
      {
        cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      if (!((nVirtKey >= VK_PRIOR && nVirtKey <= VK_HELP) || 
            (nVirtKey >= VK_NUMPAD0 && nVirtKey <= VK_SCROLL) ||
            (nVirtKey >= VK_SHIFT && nVirtKey <= VK_CAPITAL)) &&
            (flags < 10))
      {
        cptr event_type = object_integer_from(8),
             id = object_integer_from(400),
             when = object_number_from((float) get_time()),
             modifiers,
             keyCode = object_integer_from(0), 
             keyChar = object_integer_from(convert_key(nVirtKey)),
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
        UINT flags = 0;

        if (GetAsyncKeyState(VK_CONTROL) != 0)
          flags |=  2;
        if (GetAsyncKeyState(VK_SHIFT) != 0)
          flags |=  1;
        if (GetAsyncKeyState(VK_MENU) != 0)
          flags |= 8;
  
        modifiers = object_integer_from(flags);
        {
          cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    }
    FORWARD_WM_KEYDOWN(hwnd, nVirtKey, cRepeat, nFlags, proc_to_run);
  } 
  else
  {
    cptr source;
    source = lookup_value_using_hash_table(&key_listener_hash_table, hwnd);
    if (source)
    {
      cptr event_type = object_integer_from(8),
           id = object_integer_from(402),
           when = object_number_from((float) get_time()),
           modifiers,
           keyCode = object_integer_from(key_code(nVirtKey)), 
           keyChar = object_integer_from(convert_key(nVirtKey)),
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
      UINT flags = 0;

      if (GetAsyncKeyState(VK_CONTROL) != 0)
        flags |=  2;
      if (GetAsyncKeyState(VK_SHIFT) != 0)
        flags |=  1;
      if (GetAsyncKeyState(VK_MENU) != 0)
        flags |= 8;

      modifiers = object_integer_from(flags);
      {
        cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
    FORWARD_WM_KEYUP(hwnd, nVirtKey, cRepeat, nFlags, proc_to_run);
  }
}

void OnSystemKey(HWND hwnd, UINT nVirtKey, BOOL fDown, int cRepeat, UINT nFlags)
{
  if (fDown) 
  {
    cptr source;
    
    source = lookup_value_using_hash_table(&key_listener_hash_table, hwnd);
    if (source)
    {
      cptr event_type = object_integer_from(8),
           id = object_integer_from(401),
           when = object_number_from((float) get_time()),
           modifiers,
           keyCode = object_integer_from(key_code(nVirtKey)),
           keyChar = object_integer_from(convert_key(nVirtKey)),
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
      UINT flags = 0;
      if (GetAsyncKeyState(VK_CONTROL) != 0)
        flags |=  2;
      if (GetAsyncKeyState(VK_SHIFT) != 0)
        flags |=  1;
      if (GetAsyncKeyState(VK_MENU) != 0)
        flags |= 8;

      modifiers = object_integer_from(flags);
      {
        cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      if (!((nVirtKey >= VK_PRIOR && nVirtKey <= VK_HELP) || 
            (nVirtKey >= VK_NUMPAD0 && nVirtKey <= VK_SCROLL) ||
            (nVirtKey >= VK_SHIFT && nVirtKey <= VK_CAPITAL)) &&
            (flags < 10))
      {
        cptr event_type = object_integer_from(8),
             id = object_integer_from(400),
             when = object_number_from((float) get_time()),
             modifiers,
             keyCode = object_integer_from(0), 
             keyChar = object_integer_from(convert_key(nVirtKey)),
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
        UINT flags = 0;

        if (GetAsyncKeyState(VK_CONTROL) != 0)
          flags |=  2;
        if (GetAsyncKeyState(VK_SHIFT) != 0)
          flags |=  1;
        if (GetAsyncKeyState(VK_MENU) != 0)
          flags |= 8;
 
        modifiers = object_integer_from(flags);
        {
          cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    }
    FORWARD_WM_SYSKEYDOWN(hwnd, nVirtKey, cRepeat, nFlags, proc_to_run);
  } 
  else
  {
    cptr source;
    source = lookup_value_using_hash_table(&key_listener_hash_table, hwnd);
    if (source)
    {
      cptr event_type = object_integer_from(8),
           id = object_integer_from(402),
           when = object_number_from((float) get_time()),
           modifiers,
           keyCode = object_integer_from(key_code(nVirtKey)), 
           keyChar = object_integer_from(convert_key(nVirtKey)),
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 7);
      UINT flags = 0;

      if (GetAsyncKeyState(VK_CONTROL) != 0)
        flags |=  2;
      if (GetAsyncKeyState(VK_SHIFT) != 0)
        flags |=  1;
      if (GetAsyncKeyState(VK_MENU) != 0)
        flags |= 8;

      modifiers = object_integer_from(flags);
      {
        cint array_of_params[] = {source, event_type, id, when, modifiers, keyCode, keyChar, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
    }
    FORWARD_WM_SYSKEYUP(hwnd, nVirtKey, cRepeat, nFlags, proc_to_run);
  }
}

void OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags)
{
  cptr source;

  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  FORWARD_WM_LBUTTONDOWN(hwnd, fDoubleClick, pointx, pointy, nFlags, proc_to_run); 

  if (source && process_lbutton)
  {
    double timestamp = get_time();
    cptr event_type = object_integer_from(16),
         id = object_integer_from(501),
         when = object_number_from((float) timestamp),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = (timestamp - last_button < click_delay ? object_integer_from(++button_count) : object_integer_from((button_count = 1))),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    last_button = timestamp;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    flags |= 16;
    lbutton_down = TRUE;
    if (nFlags & MK_MBUTTON)
    {
      flags |= 8;
      if (!mbutton_down)
      {
        mbutton_down = TRUE;
        process_mbutton = FALSE;
      }
    }
    if (nFlags & MK_RBUTTON)
    {
      flags |= 4;
      if (!rbutton_down)
      {
        rbutton_down = TRUE;
        process_rbutton = FALSE;
      }
    }
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 
    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  process_lbutton = TRUE;
  send_click = TRUE;
}

void OnMButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags)
{
  cptr source;
    
  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  FORWARD_WM_MBUTTONDOWN(hwnd, fDoubleClick, pointx, pointy, nFlags, proc_to_run); 

  if (source && process_mbutton)
  {
    double timestamp = get_time();
    cptr event_type = object_integer_from(16),
         id = object_integer_from(501),
         when = object_number_from((float) timestamp),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = (timestamp - last_button < click_delay ? object_integer_from(++button_count) : object_integer_from((button_count = 1))),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    last_button = timestamp;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    if (nFlags & MK_LBUTTON)
    {
      flags |= 16;
      if (!lbutton_down)
      {
        lbutton_down = TRUE;
        process_lbutton = FALSE;
      }
    }
    flags |= 8;
    mbutton_down = TRUE;
    if (nFlags & MK_RBUTTON)
    {
      flags |= 4;
      if (!rbutton_down)
      {
        rbutton_down = TRUE;
        process_rbutton = FALSE;
      }
    }
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 

    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  process_mbutton = TRUE;
  send_click = TRUE;
}

void OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags)
{
  cptr source;
    
  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  FORWARD_WM_RBUTTONDOWN(hwnd, fDoubleClick, pointx, pointy, nFlags, proc_to_run);

  if (source && process_rbutton)
  {
    double timestamp = get_time();
    cptr event_type = object_integer_from(16),
         id = object_integer_from(501),
         when = object_number_from((float) timestamp),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = (timestamp - last_button < click_delay ? object_integer_from(++button_count) : object_integer_from((button_count = 1))),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    last_button = timestamp;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    if (nFlags & MK_LBUTTON)
    {
      flags |= 16;
      if (!lbutton_down)
      {
        lbutton_down = TRUE;
        process_lbutton = FALSE;
      }
    }
    if (nFlags & MK_MBUTTON)
    {
      flags |= 8;
      if (!mbutton_down)
      {
        mbutton_down = TRUE;
        process_mbutton = FALSE;
      }
    }
    flags |= 4;
    rbutton_down = TRUE;
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 

    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  process_rbutton = TRUE;
  send_click = TRUE;
}

void OnLButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  if (source)
  {
    cptr event_type = object_integer_from(16),
         id = object_integer_from(502),
         when = object_integer_from((float) get_time()),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = object_integer_from(button_count),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    flags |= 16;
    lbutton_down = FALSE;
    if (nFlags & MK_MBUTTON)
      flags |= 8;
    if (nFlags & MK_RBUTTON)
      flags |= 4;
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 

    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    
    if (send_click)
    {
      cptr event_type = object_integer_from(16),
           id = object_integer_from(500);
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      event_type[1] += 1;
      when[1] += 1;
      modifiers[1] += 1;
      x[1] += 1;
      y[1] += 1;
      clickcount[1] += 1;
      ((cint*)procedure)[1] += 1;      
  
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  moving = FALSE;

  FORWARD_WM_LBUTTONUP(hwnd, pointx, pointy, nFlags, proc_to_run);
}

void OnMButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  if (source)
  {
    cptr event_type = object_integer_from(16),
         id = object_integer_from(502),
         when = object_number_from((float) get_time()),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = object_integer_from(button_count),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    if (nFlags & MK_LBUTTON)
      flags |= 16;
    flags |= 8;
    mbutton_down = FALSE;
    if (nFlags & MK_RBUTTON)
      flags |= 4;
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 

    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }

    if (send_click)
    {
      cptr event_type = object_integer_from(16),
           id = object_integer_from(500);
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      event_type[1] += 1;
      when[1] += 1;
      modifiers[1] += 1;
      x[1] += 1;
      y[1] += 1;
      clickcount[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  moving = FALSE;

  FORWARD_WM_MBUTTONUP(hwnd, pointx, pointy, nFlags, proc_to_run);
}

void OnRButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);

  if (source)
  {
    cptr event_type = object_integer_from(16),
         id = object_integer_from(502),
         when = object_number_from((float) get_time()),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = object_integer_from(button_count),
         popuptrigger = boolean_True,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    if (nFlags & MK_LBUTTON)
      flags |= 16;
    if (nFlags & MK_MBUTTON)
      flags |= 8;
    flags |= 4;
    rbutton_down = FALSE;
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 

    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    if (send_click)
    {
      cptr event_type = object_integer_from(16),
           id = object_integer_from(500);
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, (popuptrigger = boolean_False), 0};

      source[1] += 1;
      event_type[1] += 1;
      when[1] += 1;
      modifiers[1] += 1;
      x[1] += 1;
      y[1] += 1;
      clickcount[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  moving = FALSE;

//  Calling this can cause a window's popup menu to occur (e.g. in text area)
//  We do not want this to happen.  Java allows this popup menu to occur, but
//  when adding your own popup menu, it will show the your own popup menu only on
//  every 2nd attempt
//  FORWARD_WM_RBUTTONUP(hwnd, pointx, pointy, nFlags, proc_to_run);
}

void OnMouseMove(HWND hwnd, int pointx, int pointy, UINT nFlags)
{
  cptr source;

  source = lookup_value_using_hash_table(&mouse_motion_listener_hash_table, hwnd);

  FORWARD_WM_MOUSEMOVE(hwnd, pointx, pointy, nFlags, proc_to_run);

  if (source && moving)  
  {
    cptr event_type = object_integer_from(32),
         id = object_integer_from((nFlags & (MK_LBUTTON | MK_RBUTTON | MK_MBUTTON)) ? 506 : 503),
         when = object_integer_from((float) get_time()),
         modifiers,
         x = object_integer_from(pointx),
         y = object_integer_from(pointy),
         clickcount = object_integer_from(0),
         popuptrigger = boolean_False,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
    int flags=0;

    if (nFlags & MK_CONTROL)
      flags |= 2;
    if (nFlags & MK_SHIFT)
      flags |= 1;
    if (GetAsyncKeyState(VK_MENU) != 0)
      flags |= 8;

    modifiers = object_integer_from(flags); 
    {
      cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  moving = TRUE;
  if (last_x != pointx || last_y != pointy)
    send_click = FALSE;
  last_x = pointx;
  last_y = pointy;
}

void OnSetFocus(HWND hwnd, HWND hwndLoseFocus)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&focus_listener_hash_table, hwnd);
  if (source)
  {
    cptr event_type = object_integer_from(4),
         id = object_integer_from(1004),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 4);
    RECT r;
  
    {
      cint array_of_params[] = {source, event_type, id, boolean_False, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  FORWARD_WM_SETFOCUS(hwnd, hwndLoseFocus, proc_to_run);
}

void OnKillFocus(HWND hwnd, HWND hwndGetFocus)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&focus_listener_hash_table, hwnd);
  if (source)
  {
    cptr event_type = object_integer_from(4),
         id = object_integer_from(1005),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 4);
    RECT r;
  
    {
      cint array_of_params[] = {source, event_type, id, (hwndGetFocus != NULL) ? boolean_False : boolean_True, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  FORWARD_WM_KILLFOCUS(hwnd, hwndGetFocus, proc_to_run);
}

void OnClose(HWND hwnd)
{
  cptr source;
  
  source = lookup_value_using_hash_table(&window_listener_hash_table, hwnd);
  if (source)
  {
    cptr event_type = object_integer_from(64),
         id = object_integer_from(201),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    RECT r;
  
    {
      cint array_of_params[] = {source, event_type, id, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
}

void OnVScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos)
{
  cptr source = lookup_value_using_hash_table(&adjustment_listener_hash_table, hwndCtl);

  if (code == SB_TOP || code == SB_BOTTOM || code == SB_ENDSCROLL || code == SB_THUMBPOSITION)
    return;

  if (source)
  {
    cptr event_type = object_integer_from(256), //AWTEvent.ADJUSTMENT_EVENT_MASK
         id = object_integer_from(601),
         type = object_integer_from((code == SB_LINEUP) ? 2 :        //AdjustmentEvent.UNIT_DECREMENT
                                    (code == SB_LINEDOWN) ? 1 :      //AdjustmentEvent.UNIT_INCREMENT
                                    (code == SB_PAGEUP) ? 3 :        //AdjustmentEvent.BLOCK_DECREMENT
                                    (code == SB_PAGEDOWN) ? 4 : 5),  //AdjustmentEvent.BLOCK_INCREMENT else AdjustmentEvent.TRACK
         track = object_integer_from(pos),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
    {   
      cint array_of_params[] = {source, event_type, id, type, track, 0};
 
      source[1] += 1;
      ((cint*)procedure)[1] += 1;
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  else
    FORWARD_WM_VSCROLL(hwnd, hwndCtl, code, pos, proc_to_run);
}

void OnHScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos)
{
  cptr source = lookup_value_using_hash_table(&adjustment_listener_hash_table, hwndCtl);

  if (code == SB_TOP || code == SB_BOTTOM || code == SB_ENDSCROLL || code == SB_THUMBPOSITION)
    return;

  if (source)
  {
    cptr event_type = object_integer_from(256), //AWTEvent.ADJUSTMENT_EVENT_MASK
         id = object_integer_from(601),
         type = object_integer_from((code == SB_LINEUP) ? 2 :        //AdjustmentEvent.UNIT_DECREMENT
                                    (code == SB_LINEDOWN) ? 1 :      //AdjustmentEvent.UNIT_INCREMENT
                                    (code == SB_PAGEUP) ? 3 :        //AdjustmentEvent.BLOCK_DECREMENT
                                    (code == SB_PAGEDOWN) ? 4 : 5),  //AdjustmentEvent.BLOCK_INCREMENT else AdjustmentEvent.TRACK
         track = object_integer_from(pos),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
    {   
      cint array_of_params[] = {source, event_type, id, type, track, 0};
 
      source[1] += 1;
      ((cint*)procedure)[1] += 1;
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
  else
    FORWARD_WM_HSCROLL(hwnd, hwndCtl, code, pos, proc_to_run);
}

void OnGotFocus(HWND hwnd, UINT fActive, HWND tempwnd, BOOL fMinimized)
{
  cptr source;

  FORWARD_WM_ACTIVATE(hwnd, fActive, tempwnd, fMinimized, proc_to_run);

  source = lookup_value_using_hash_table(&window_listener_hash_table, hwnd);
 
  if (source)
  {
    cptr event_type = object_integer_from(64),
         id,
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);

    int whatID;

    if ((fActive == WA_ACTIVE || fActive == WA_CLICKACTIVE) && !fMinimized)
      whatID = 205;
    else if ((fActive == WA_ACTIVE || fActive == WA_CLICKACTIVE) && fMinimized)
      whatID = 204;
    else if (fActive == WA_INACTIVE && !fMinimized)
      whatID = 206;
    else if (fActive == WA_INACTIVE && fMinimized)
      whatID = 203;
    else
      whatID = 205;
    id = object_integer_from(whatID);
    {
      cint array_of_params[] = {source, event_type, id, 0};

      source[1] += 1;
      ((cint*)procedure)[1] += 1;
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    if (whatID == 203)
    {
      cptr event_type = object_integer_from(64),
           id = object_integer_from(206);
      cint array_of_params[] = {source, event_type, id, 0};

      source[1] += 1;
      event_type[1] += 1;
      ((cint*)procedure)[1] += 1;
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
  }
}

BOOL OnSetCursor(HWND hwnd, HWND which_hwnd, int nHitTest, int wMouseMsg)
{
  if (nHitTest == HTCLIENT)
  {
    {
      cptr source;
  
      source = lookup_value_using_hash_table(&component_listener_hash_table, which_hwnd);
      if (source)
      {
        cptr event_type = object_integer_from(0),
             id = object_integer_from(0),
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
        {
          cint array_of_params[] = {source, event_type, id, 0};
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    }
    return TRUE;
  }
  FORWARD_WM_SETCURSOR(hwnd, which_hwnd, nHitTest, wMouseMsg, proc_to_run);
  return FALSE;
}

void show_window(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  send_setVisible = FALSE;

  ShowWindow(hwnd, SW_SHOWNORMAL);       // prepare to display window minimised/normal initially
  InvalidateRect(hwnd, NULL, TRUE);   
//  UpdateWindow(hwnd);                    // send window WM_PAINT message

  object_Dec_ref(handle);
}

void hide_window(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  send_setVisible = FALSE;

  ShowWindow(hwnd, SW_HIDE);       // prepare to display window minimised/normal initially
  UpdateWindow(hwnd);               // send window WM_PAINT message

  object_Dec_ref(handle);
}

void enable_window(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  EnableWindow(hwnd, TRUE);

  object_Dec_ref(handle);
}

void disable_window(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  EnableWindow(hwnd, FALSE);

  object_Dec_ref(handle);
}

void move_window(cptr handle, cptr x_val, cptr y_val, cptr width_val, cptr height_val)
{
  HWND hwnd = object_as_int(handle);
  cint x = object_as_int(x_val),
       y = object_as_int(y_val),
       width = object_as_int(width_val),
       height = object_as_int(height_val);
  POINT p = {x, y};
  RECT r;

  if (hwnd == NULL)
    return;

//  send_setSize++;
//  send_Move++;

  GetWindowRect(hwnd, &r);
  if ((r.left != x) || (r.top != y))
    send_Move++;
  if ((r.right - r.left != width) || (r.bottom - r.top != height))
    send_setSize++;

  ScreenToClient(GetParent(hwnd), &p);

  MoveWindow(hwnd, p.x, p.y, width, height, TRUE);

  sizing = FALSE;

  object_Dec_ref(handle);
  object_Dec_ref(x_val);
  object_Dec_ref(y_val);
  object_Dec_ref(width_val);
  object_Dec_ref(height_val);
}

cptr get_location_on_screen(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  RECT r;

  if (hwnd == NULL)
    return;

  GetWindowRect(hwnd, &r);

  object_Dec_ref(handle);
  
  {
    cptr xy[] = {object_integer_from(r.left), object_integer_from(r.top), 0};
    return object_list_from(xy);
  }
}

void set_cursor(cptr handle, cptr cursor)
{
  HWND hwnd = object_as_int(handle);
  cint cursortype = object_as_int(cursor);

  if (hwnd == NULL)
    return;

  switch (cursortype) {
    case 0  : SetClassLong(hwnd, GCL_HCURSOR, default_cursor);
              SetCursor(default_cursor); break;
    case 1  : SetClassLong(hwnd, GCL_HCURSOR, crosshair_cursor);
              SetCursor(crosshair_cursor); break;
    case 2  : SetClassLong(hwnd, GCL_HCURSOR, text_cursor);
              SetCursor(text_cursor); break;
    case 3  : SetClassLong(hwnd, GCL_HCURSOR, wait_cursor);
              SetCursor(wait_cursor); break;
    case 4  : SetClassLong(hwnd, GCL_HCURSOR, sw_resize_cursor);
              SetCursor(sw_resize_cursor); break;
    case 5  : SetClassLong(hwnd, GCL_HCURSOR, se_resize_cursor);
              SetCursor(se_resize_cursor); break;
    case 6  : SetClassLong(hwnd, GCL_HCURSOR, nw_resize_cursor);
              SetCursor(nw_resize_cursor); break;
    case 7  : SetClassLong(hwnd, GCL_HCURSOR, se_resize_cursor);
              SetCursor(se_resize_cursor); break;
    case 8  : SetClassLong(hwnd, GCL_HCURSOR, n_resize_cursor);
              SetCursor(n_resize_cursor); break;
    case 9  : SetClassLong(hwnd, GCL_HCURSOR, s_resize_cursor);
              SetCursor(s_resize_cursor); break;
    case 10 : SetClassLong(hwnd, GCL_HCURSOR, w_resize_cursor);
              SetCursor(w_resize_cursor); break;
    case 11 : SetClassLong(hwnd, GCL_HCURSOR, e_resize_cursor);
              SetCursor(e_resize_cursor); break;
    case 12 : SetClassLong(hwnd, GCL_HCURSOR, hand_cursor);
              SetCursor(hand_cursor); break;
    case 13 : SetClassLong(hwnd, GCL_HCURSOR, move_cursor);
              SetCursor(move_cursor); break;
  }

  object_Dec_ref(handle);
  object_Dec_ref(cursor);
}

HBRUSH OnCtlColorBtn(HWND hwnd, HDC dc, HWND hwndbutton)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwndbutton);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}

HBRUSH OnCtlColorStatic(HWND hwnd, HDC dc, HWND hwndstatic)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwndstatic);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }

    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}

HBRUSH OnCtlColorEdit(HWND hwnd, HDC dc, HWND hwndedit)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwndedit);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
//    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}

HBRUSH OnCtlColorScrollbar(HWND hwnd, HDC dc, HWND hwndscrollbar)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwndscrollbar);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}

HBRUSH OnCtlColorListbox(HWND hwnd, HDC dc, HWND hwndlistbox)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwndlistbox);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}

HBRUSH OnCtlColorChoiceListbox(HWND hwnd, HDC dc, HWND hwndlistbox)
{
  cptr source;
  source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
  if (source)
  {
    cptr event_type = object_integer_from(0),
         id = object_integer_from(1),
         procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 3);
    {
      cint array_of_params[] = {source, event_type, id, 0};
      source[1] += 1;
      ((cint*)procedure)[1] += 1;      
      procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
    }
    SetTextColor(dc, RGB(fRed, fGreen, fBlue));
    SetBkMode(dc, TRANSPARENT);
    SetBkColor(dc, RGB(bRed, bGreen, bBlue));
    if (brush != NULL)
      DeleteObject(brush);
    brush = CreateSolidBrush(RGB(bRed, bGreen, bBlue));
    return brush;
  }
}


void request_focus(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  SetFocus(hwnd);

  object_Dec_ref(handle);
}

cptr get_component_preferred_size(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  HDC dc;
  SIZE size;
  char *s;
  int string_length;
  HFONT old_hfont;

  if (hwnd == NULL)
    return object_Undefined;

  dc = GetDC(hwnd);
  old_hfont = SelectObject(dc, GetWindowFont(hwnd));

  string_length = GetWindowTextLength(hwnd);
  s = mem_malloc(string_length+1);

  GetWindowText(hwnd, s, string_length+1);
  GetTextExtentPoint32(dc, s, string_length, &size);

  mem_free(s);
  SelectObject(dc, old_hfont);
  ReleaseDC(hwnd, dc);

  object_Dec_ref(handle);

  {
    cptr width_and_height[] = {object_integer_from(7 + size.cx + 7), 
                               object_integer_from(4 + size.cy + 4), 0};
    return object_list_from(width_and_height);
  }
}

void enable_events(cptr objectID, cptr object, cptr events)
{
  cint key = object_as_int(objectID);
  cint events_to_enable = object_as_int(events);
  if (events_to_enable & 1) 
  {
    if (!lookup_value_using_hash_table(&component_listener_hash_table, key))
      add_to_hash_table(&component_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&component_listener_hash_table, key);

  if (events_to_enable & 4) 
  {
    if (!lookup_value_using_hash_table(&focus_listener_hash_table, key))
      add_to_hash_table(&focus_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&focus_listener_hash_table, key);

  if (events_to_enable & 8) 
  {
    if (!lookup_value_using_hash_table(&key_listener_hash_table, key))
      add_to_hash_table(&key_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&key_listener_hash_table, key);

  if (events_to_enable & 16) 
  {
    if (!lookup_value_using_hash_table(&mouse_listener_hash_table, key))
      add_to_hash_table(&mouse_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&mouse_listener_hash_table, key);

  if (events_to_enable & 32) 
  {
    if (!lookup_value_using_hash_table(&mouse_motion_listener_hash_table, key))
      add_to_hash_table(&mouse_motion_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&mouse_motion_listener_hash_table, key);

  if (events_to_enable & 64) 
  {
    if (!lookup_value_using_hash_table(&window_listener_hash_table, key))
      add_to_hash_table(&window_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&window_listener_hash_table, key);

  if (events_to_enable & 128) 
  {
    if (!lookup_value_using_hash_table(&action_listener_hash_table, key))
      add_to_hash_table(&action_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&action_listener_hash_table, key);

  if (events_to_enable & 256) 
  {
    if (!lookup_value_using_hash_table(&adjustment_listener_hash_table, key))
      add_to_hash_table(&adjustment_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&adjustment_listener_hash_table, key);

  if (events_to_enable & 512) 
  {
    if (!lookup_value_using_hash_table(&item_listener_hash_table, key))
      add_to_hash_table(&item_listener_hash_table, key, object);
  }
  else
    remove_from_hash_table(&item_listener_hash_table, key);

  if (events_to_enable & 1024) 
  {
    if (!lookup_value_using_hash_table(&text_listener_hash_table, key))
      add_to_hash_table(&text_listener_hash_table, key, object);
  } 
  else
    remove_from_hash_table(&text_listener_hash_table, key);
 
  object_Dec_ref(objectID);
  object_Dec_ref(events);
}

void dispose_component(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  DestroyWindow(hwnd);

  object_Dec_ref(handle);
}

void dispose_modal(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  modaldialogsrunning--;

  DestroyWindow(hwnd);

  object_Dec_ref(handle);
}

void to_back(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

//  send_Move++;
  
  SetWindowPos(hwnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE);

  object_Dec_ref(handle);
}

cptr get_insets(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  RECT rect, client_rect; 
  POINT p;

  if (hwnd == NULL)
    return object_Undefined;
 
  GetWindowRect(hwnd, &rect), 
  GetClientRect(hwnd, &client_rect);

  p.x = client_rect.left;
  p.y = client_rect.top;
  ClientToScreen(hwnd, &p);
  client_rect.left = p.x;
  client_rect.top = p.y;
  p.x = client_rect.right;
  p.y = client_rect.bottom;
  ClientToScreen(hwnd, &p);
  client_rect.right = p.x;
  client_rect.bottom = p.y;

  object_Dec_ref(handle);

  {
    cptr list[] = {object_integer_from(client_rect.top - rect.top), 
                 object_integer_from(client_rect.left - rect.left), 
                 object_integer_from(rect.bottom - client_rect.bottom), 
                 object_integer_from(rect.right - client_rect.right), 0};

    return object_list_from(list);
  }

}

void move_container_window(cptr handle, cptr x_val, cptr y_val, cptr width_val, cptr height_val)
{
  HWND hwnd = object_as_int(handle);
  cint x = object_as_int(x_val),
       y = object_as_int(y_val),
       width = object_as_int(width_val),
       height = object_as_int(height_val),
       new_width, new_height;
  RECT r;

  if (hwnd == NULL)
    return;

  GetWindowRect(hwnd, &r);

  if ((r.left != x) || (r.top != y))
    send_Move++;
  if ((r.right - r.left != width) || (r.bottom - r.top != height))
    send_setSize++;

//  send_setSize++;
//  send_Move++;
//printf("mov_con_wnd %d\n", send_Move);
//printf("%d sizing %d\n", hwnd, send_setSize);
  MoveWindow(hwnd, x, y, width, height, TRUE);
  GetWindowRect(hwnd, &r);
  new_width = r.right - r.left;
  new_height = r.bottom - r.top;
  if (new_width != width || new_height != height)
  {
    cptr source;
  
    source = lookup_value_using_hash_table(&component_listener_hash_table, hwnd);
    if (source)
    {
      cptr event_type = object_integer_from(1),
           id = object_integer_from(101),
           width = object_integer_from(new_width),
           height = object_integer_from(new_height), 
           procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
      {
        cint array_of_params[] = {source, event_type, id, width, height, 0};
        source[1] += 1;
        ((cint*)procedure)[1] += 1;      
        procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
      }
      InvalidateRect(hwnd, NULL, TRUE); 
    }
  }  
  object_Dec_ref(handle);
  object_Dec_ref(x_val);
  object_Dec_ref(y_val);
  object_Dec_ref(width_val);
  object_Dec_ref(height_val);
}

void to_front(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

//  send_Move++;

  SetWindowPos(hwnd, HWND_TOP, 0, 0, 0, 0, SWP_SHOWWINDOW | SWP_NOMOVE | SWP_NOSIZE);

  object_Dec_ref(handle);
}

cptr create_frame()
{
  HWND hwnd;

  hwnd = CreateWindow(
    "Slim Frame", //classname,
    NULL,
    WS_OVERLAPPEDWINDOW,
    0,
    0,
    0,
    0,
    NULL,
    NULL,
    hInstance,
    NULL
  );

//  if (!created_frame_before)
//  {
//    send_Move++;
//    created_frame_before = TRUE;
//  }

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

cptr create_dialog(cptr parent)
{
  HWND hwnd,
       parent_frame = ((parent != object_Undefined) ? object_as_int(parent) : NULL);

  send_Move++;

  hwnd = CreateWindow(
    "Slim Dialog",
    NULL,
    WS_POPUP | WS_CAPTION | DS_SETFONT | WS_SYSMENU,
    0,
    0,
    0,
    0,
    parent_frame,
    NULL,
    hInstance,
    NULL
  );

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

cptr create_window(cptr parent)
{
  HWND hwnd,
       parent_frame = ((parent != object_Undefined) ? object_as_int(parent) : NULL);

  send_Move++;

  hwnd = CreateWindow(
    "Slim Window",
    NULL,
    WS_POPUP,
    0,
    0,
    0,
    0,
    parent_frame,
    NULL,
    hInstance,
    NULL
  );

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void set_title(cptr handle, cptr title)
{
  HWND hwnd = object_as_int(handle);
  cstring str = object_as_string(title);

  if (hwnd == NULL)
    return;

  SetWindowText(hwnd, str);
  mem_free(str);
  object_Dec_ref(handle);
  object_Dec_ref(title);
}

void enable_sizable(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) | WS_SIZEBOX);
  InvalidateRect(hwnd, NULL, TRUE); 

  object_Dec_ref(handle);
}

void disable_sizable(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, GetWindowLong(hwnd, GWL_STYLE) & ~WS_SIZEBOX);
  InvalidateRect(hwnd, NULL, TRUE);

  object_Dec_ref(handle);
}

cptr create_panel(cptr parent)
{
  HWND hwnd,
       parent_frame = ((parent != object_Undefined) ? object_as_int(parent) : NULL);

  send_Move++;
  
  hwnd = CreateWindow(
    "Slim Panel",
    NULL,
    WS_CHILD | WS_VISIBLE,
    0,
    0,
    0,
    0,
    parent_frame,
    NULL,
    hInstance,
    NULL
  );
  if (parent != object_Undefined)
    object_Dec_ref(parent);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

cptr create_label(cptr parent)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("static", NULL, WS_CHILD | WS_VISIBLE | SS_CENTERIMAGE, 
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  if (hwnd != NULL)
    DefLabelProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, LabelProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void set_left_alignment(cptr label)
{
  HWND hwnd = object_as_int(label);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) | SS_LEFT) & ~(SS_CENTER | SS_RIGHT));
  InvalidateRect(hwnd, NULL, TRUE);

  object_Dec_ref(label);
}

void set_center_alignment(cptr label)
{
  HWND hwnd = object_as_int(label);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) | SS_CENTER) & ~(SS_LEFT | SS_RIGHT));
  InvalidateRect(hwnd, NULL, TRUE);

  object_Dec_ref(label);
}
void set_right_alignment(cptr label)
{
  HWND hwnd = object_as_int(label);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) | SS_RIGHT) & ~(SS_LEFT | SS_CENTER));
  InvalidateRect(hwnd, NULL, TRUE);

  object_Dec_ref(label);
}

cptr create_button(cptr parent)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("button", NULL, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  if (hwnd != NULL)
    DefButtonProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, ButtonProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

cptr create_checkbox(cptr parent)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("button", NULL, WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX, 
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  if (hwnd != NULL)
    DefCheckboxProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, CheckboxProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void check_checkbox(cptr checkbox)
{
  HWND hwnd = object_as_int(checkbox);

  if (hwnd == NULL)
    return;

  SendMessage(hwnd, BM_SETCHECK, TRUE, 0L);

  object_Dec_ref(checkbox);
}

void uncheck_checkbox(cptr checkbox)
{
  HWND hwnd = object_as_int(checkbox);

  if (hwnd == NULL)
    return;

  SendMessage(hwnd, BM_SETCHECK, FALSE, 0L);

  object_Dec_ref(checkbox);
}

cptr create_choice(cptr parent)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("combobox", NULL, WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST
                           | WS_VSCROLL, 0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);
  if (hwnd != NULL)
    DefChoiceProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, ChoiceProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void add_choice_string(cptr choice, cptr string, cptr index)
{
  HWND hwnd = object_as_int(choice);
  cint position = object_as_int(index);
  cstring string_to_add = object_as_string(string);

  if (hwnd == NULL)
    return;
  
  ComboBox_InsertString(hwnd, position, string_to_add);

  mem_free(string_to_add);

  object_Dec_ref(string);
  object_Dec_ref(index);
  object_Dec_ref(choice);
}

void remove_choice_string(cptr choice, cptr index)
{
  HWND hwnd = object_as_int(choice);
  cint position = object_as_int(index);

  if (hwnd == NULL)
    return;
  
  ComboBox_DeleteString(hwnd, position);

  object_Dec_ref(index);
  object_Dec_ref(choice);
}

void select_choice_string(cptr choice, cptr index)
{
  HWND hwnd = object_as_int(choice);
  cint position = object_as_int(index);

  if (hwnd == NULL)
    return;
  
  ComboBox_SetCurSel(hwnd, position);

  object_Dec_ref(index);
  object_Dec_ref(choice);
}

void morph_into_radiobutton(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) & ~BS_AUTOCHECKBOX) | BS_AUTORADIOBUTTON);
  InvalidateRect(hwnd, NULL, TRUE); 

  object_Dec_ref(handle);
}

void morph_into_checkbox(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  SetWindowLong(hwnd, GWL_STYLE, (GetWindowLong(hwnd, GWL_STYLE) & ~BS_AUTORADIOBUTTON) | BS_AUTOCHECKBOX);
  InvalidateRect(hwnd, NULL, TRUE); 

  object_Dec_ref(handle);
}

cptr get_choice_preferred_size(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  HDC dc;
  SIZE size;
  char *s;
  int string_length, i, numitems, maxlength = 0, maxheight = 0;
  HFONT old_hfont;
  TEXTMETRIC textmetric;
  
  if (hwnd == NULL)
    return;

  dc = GetDC(hwnd);
  old_hfont = SelectObject(dc, GetWindowFont(hwnd));
  GetTextMetrics(dc, &textmetric);

  numitems = ComboBox_GetCount(hwnd);
  if (numitems != CB_ERR)
    for (i = 0; i < numitems; i++)
    {
      string_length = ComboBox_GetLBTextLen(hwnd, i);
      s = mem_malloc(string_length+1);

      ComboBox_GetLBText(hwnd, i, s);
      GetTextExtentPoint32(dc, s, string_length, &size);

      maxlength = (size.cx <= maxlength) ? maxlength : size.cx;
      mem_free(s);
    }

  SelectObject(dc, old_hfont);
  ReleaseDC(hwnd, dc);

  object_Dec_ref(handle);
  
  {
    cptr width_and_height[] = {object_integer_from(maxlength), 
                               object_integer_from(textmetric.tmHeight), 0};
    return object_list_from(width_and_height);
  }
}


cptr create_list(cptr parent, cptr multiple)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("listbox", NULL, WS_CHILD | WS_VISIBLE | LBS_STANDARD | LBS_NOTIFY | 
                           LBS_WANTKEYBOARDINPUT | (multiple == boolean_True ? LBS_MULTIPLESEL : 0),
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);

  if (hwnd != NULL)
    DefListProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, ListProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);

}

void set_editable(cptr handle, cptr editable)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  if (editable == boolean_True)
    Edit_SetReadOnly(hwnd, FALSE);
  else if (editable == boolean_False)
    Edit_SetReadOnly(hwnd, TRUE);

  object_Dec_ref(handle);
}

cptr get_text(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  int textlength;
  char *string;

  if (hwnd == NULL)
    return;

  object_Dec_ref(handle);

  textlength = Edit_GetTextLength(hwnd);
  string = mem_malloc(textlength+1);
  Edit_GetText(hwnd, string, textlength+1);

  return object_string_from(string);
}

void set_text(cptr handle, cptr string)
{
  HWND hwnd = object_as_int(handle);
  cstring *s = object_as_string(string);

  if (hwnd == NULL)
    return;
  Edit_SetText(hwnd, s);
  mem_free(s);
  object_Dec_ref(handle); //move this to before return later
  object_Dec_ref(string);
}

cptr get_selection_start(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  DWORD selection;

  if (hwnd == NULL)
    return;

  selection = Edit_GetSel(hwnd);

  object_Dec_ref(handle);

  return object_integer_from(LOWORD(selection));
}

cptr get_selection_end(cptr handle)
{
  HWND hwnd = object_as_int(handle);
  DWORD selection;

  if (hwnd == NULL)
    return;

  selection = Edit_GetSel(hwnd);

  object_Dec_ref(handle);

  return object_integer_from(HIWORD(selection));
}

void text_component_select(cptr handle, cptr start, cptr end)
{
  HWND hwnd = object_as_int(handle);
  cint sel_start = object_as_int(start),
       sel_end = object_as_int(end);

  object_Dec_ref(handle);
  object_Dec_ref(start);
  object_Dec_ref(end);

  if (hwnd == NULL)
    return;

  Edit_SetSel(hwnd, sel_start, sel_end);
  Edit_ScrollCaret(hwnd);
}

cptr create_textfield(cptr parent)
{
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", NULL, WS_CHILD | WS_VISIBLE | WS_BORDER | 
                             ES_AUTOHSCROLL | ES_NOHIDESEL,
                             0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);
  
  if (hwnd != NULL)
    DefTextProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, TextProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void set_echo_char(cptr handle, cptr character)
{
  HWND hwnd = object_as_int(handle);
  cstring *s = object_as_string(character);
  char ch = s[0];

  if (hwnd == NULL)
    return;

  Edit_SetPasswordChar(hwnd, ch);
  InvalidateRect(hwnd, NULL, TRUE); 

  mem_free(s);
  object_Dec_ref(handle);
  object_Dec_ref(character);
}

cptr create_textarea(cptr parent, cptr scrollbar_visibility)
{
  cint sbv = object_as_int(scrollbar_visibility);
  int WS_SCROLL = (sbv == 0) ? WS_HSCROLL | WS_VSCROLL :
                  (sbv == 1) ? WS_VSCROLL :
                  (sbv == 2) ? WS_HSCROLL : 0;

  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", NULL, WS_CHILD | WS_VISIBLE | WS_SCROLL |
                           ES_MULTILINE | ES_AUTOVSCROLL | ES_WANTRETURN | ES_NOHIDESEL,
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);

  if (parent != object_Undefined)
    object_Dec_ref(parent);
  object_Dec_ref(scrollbar_visibility);
  
  if (hwnd != NULL)
    DefTextProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, TextProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void replace_range(cptr handle, cptr string)
{
  HWND hwnd = object_as_int(handle);
  cstring *s = object_as_string(string);

  if (hwnd == NULL)
    return;

  Edit_ReplaceSel(hwnd, s);

  mem_free(s);
}

cptr create_scrollbar(cptr parent, cptr orientation)
{
  cint sb_orientation = object_as_int(orientation);
  HWND parent_window = ((parent != object_Undefined) ? object_as_int(parent) : NULL),
       hwnd = CreateWindow("scrollbar", NULL, WS_CHILD | WS_VISIBLE |
                            ((sb_orientation == 0) ? SBS_HORZ : SBS_VERT), //all my problems because of the brackets!!
                           0, 0, 0, 0, parent_window, NULL, hInstance, NULL);
  if (parent != object_Undefined)
    object_Dec_ref(parent);
  object_Dec_ref(orientation);

  
  if (hwnd != NULL)
    DefScrollbarProc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, ScrollbarProc);

  return (hwnd != NULL ? object_integer_from(hwnd) : object_Undefined);
}

void set_values(cptr handle, cptr val, cptr vis, cptr min, cptr max)
{
  HWND hwnd = object_as_int(handle);
  cint value = object_as_int(val),
       visible = object_as_int(vis),
       minimum = object_as_int(min),
       maximum = object_as_int(max);
  SCROLLINFO s;

  object_Dec_ref(handle);
  object_Dec_ref(val);
  object_Dec_ref(vis);
  object_Dec_ref(min);
  object_Dec_ref(max);

  if (hwnd == NULL)
    return;

  s.cbSize = sizeof(SCROLLINFO);
  s.fMask = SIF_ALL;
  s.nMin = minimum;
  s.nMax = maximum - visible;
  s.nPage = visible;
  s.nPos = value;

  SetScrollInfo(hwnd, SB_CTL, &s, TRUE);
}

void set_component_label(cptr component, cptr title)
{
  HWND hwnd = object_as_int(component);
  cstring str = object_as_string(title);

  SetWindowText(hwnd, str);

  mem_free(str);
  object_Dec_ref(component);
  object_Dec_ref(title);
}

int CALLBACK GetFontList(LPENUMLOGFONT lpnlf, LPNEWTEXTMETRIC lpntm, int FontType, cptr *FontList)
{
  int strlength = strlen(lpnlf->elfLogFont.lfFaceName);
  char *ascii_string = mem_malloc(strlength+1);
  int temp;

  strcpy(ascii_string, lpnlf->elfLogFont.lfFaceName);

//  FontList[tempcounter] = object_integer_from(ascii_string);

  temp = tempcounter;
  if (temp == 0)
    FontList[0] = ascii_string;
  else
    while ((temp > 0) && (strcmpi(FontList[temp-1], ascii_string) > 0))
    {
      FontList[temp] = FontList[temp-1];
      temp--;
    }

  FontList[temp] = ascii_string;
  tempcounter++;
  return 1;
}

int CALLBACK CountFonts(LPENUMLOGFONT lpnlf, LPNEWTEXTMETRIC lpntm, int FontType, int *numFonts)
{
  (*numFonts)++;
  return 1;
}


cptr get_font_list()
{
  int numFonts=0;

  HWND hwnd = GetFocus();
  HDC dc = GetDC(hwnd);
  cptr font_list;
  int i;

  EnumFontFamilies(dc, NULL, CountFonts, &numFonts);

  FontList = mem_malloc((numFonts+1)*4);

  tempcounter = 0;

  EnumFontFamilies(dc, NULL, GetFontList, FontList);

  FontList[numFonts] = 0;

  for (i = 0; i < numFonts; i++)
    FontList[i] = object_string_from(FontList[i]);

  font_list = object_list_from(FontList);

  mem_free(FontList);
  FontList = NULL;

  ReleaseDC(hwnd, dc);

  return (font_list != NULL ? font_list : object_Undefined);
}

cint and_bits(cptr num1, cptr num2)
{
  int a = object_as_int(num1),
      b = object_as_int(num2);
  
  object_Dec_ref(num1);
  object_Dec_ref(num2);
  
  return object_integer_from(a & b);
}

cint or_bits(cptr num1, cptr num2)
{
  int a = object_as_int(num1),
      b = object_as_int(num2);
  
  object_Dec_ref(num1);
  object_Dec_ref(num2);
  
  return object_integer_from(a | b);
}

cint not_bits(cptr num1)
{
  int a = object_as_int(num1),
  
  object_Dec_ref(num1);
  
  return object_integer_from(~a);
}

cint xor_bits(cptr num1, cptr num2)
{
  int a = object_as_int(num1),
      b = object_as_int(num2);
  
  object_Dec_ref(num1);
  object_Dec_ref(num2);
  
  return object_integer_from(a ^ b);
}

LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam) 
{ 
  MOUSEHOOKSTRUCT *m = lParam;
  HWND hwnd;

  if (nCode < 0)  // do not process the message 
    return CallNextHookEx(MouseHook, nCode, wParam, lParam);  

  if (sizinghwnd != m->hwnd)
  {
    if (sizing)
    {
      cptr source;
  
      source = lookup_value_using_hash_table(&component_listener_hash_table, sizinghwnd);
      if (source && send_setSize == 0)
      {
        cptr event_type = object_integer_from(1),
             id = object_integer_from(101),
             width,
             height, 
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 5);
        RECT r;
        GetWindowRect(sizinghwnd, &r);
        width = object_integer_from(r.right - r.left);
        height = object_integer_from(r.bottom - r.top);
        {
          cint array_of_params[] = {source, event_type, id, width, height, 0};
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
        InvalidateRect(hwnd, NULL, TRUE); 
      }  
      sizing = FALSE;
      send_setSize = 0;
      sizinghwnd = m->hwnd;
    }
  }
  hwnd = WindowFromPoint(m->pt);
  if (currenthwnd != hwnd)
  {
    RECT r_currenthwnd, r_hwnd;

    GetWindowRect(currenthwnd, &r_currenthwnd);
    GetWindowRect(hwnd, &r_hwnd);
 
    {
      cptr source;
  
      source = lookup_value_using_hash_table(&mouse_listener_hash_table, currenthwnd);
  
      if (source)
      {
        cptr event_type = object_integer_from(16),
             id = object_integer_from(505),
             when = object_number_from((float) get_time()),
             modifiers = object_integer_from(0),
             x = object_integer_from(m->pt.x - r_currenthwnd.left),
             y = object_integer_from(m->pt.y - r_currenthwnd.top),
             clickcount = object_integer_from((button_count = 0)),
             popuptrigger = boolean_False,
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
        {
          cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};
  
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        }
      }
    } 
    {
      cptr source;
  
      source = lookup_value_using_hash_table(&mouse_listener_hash_table, hwnd);
  
      if (source)
      {
        cptr event_type = object_integer_from(16),
             id = object_integer_from(504),
             when = object_number_from((float) get_time()),
             modifiers = object_integer_from(0),
             x = object_integer_from((!lbutton_down && !mbutton_down && !rbutton_down) ? m->pt.x - r_currenthwnd.left : m->pt.x - r_hwnd.left),
             y = object_integer_from((!lbutton_down && !mbutton_down && !rbutton_down) ? m->pt.y - r_currenthwnd.top : m->pt.y - r_hwnd.top),
             clickcount = object_integer_from((button_count = 0)),
             popuptrigger = boolean_False,
             procedure = identifier_lookup_in_given_scope_and_curr(manage_event_ID, source, 9);
        {
          cint array_of_params[] = {source, event_type, id, when, modifiers, x, y, clickcount, popuptrigger, 0};
  
          source[1] += 1;
          ((cint*)procedure)[1] += 1;      
          procedure_Call_with_params(procedure, (cptr) object_list_from((cptr) array_of_params));
        } 
      }
    }
    currenthwnd = hwnd;
    button_count = 0;
    send_click = FALSE;
  }

  return CallNextHookEx(MouseHook, nCode, wParam, 
        lParam); 
}

//Time in seconds since 1970.  Should be in milliseconds,
//but not enough bits to store in milliseconds.

double get_time()
{
  long ltime;
  struct _timeb tstruct;
  double t;

  time(&ltime);
  
  _ftime(&tstruct);
  t = ltime + tstruct.timezone * 60;

  t *= 1000;
  t += tstruct.millitm;

  return t;
}

void inc_move_counter()
{
  send_Move++;
}

void dec_move_counter()
{
  send_Move--;
}

void inc_size_counter()
{
  send_setSize++;
}

cptr load_system_colors()
{
  cptr color_list[] = {
    object_integer_from(0xFF000000 | GetSysColor(COLOR_DESKTOP)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_ACTIVECAPTION)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_CAPTIONTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_ACTIVEBORDER)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_INACTIVECAPTION)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_INACTIVECAPTIONTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_INACTIVEBORDER)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_WINDOW)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_WINDOWFRAME)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_WINDOWTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_MENU)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_MENUTEXT)),
    object_integer_from(0xFF000000 | RGB(192, 192, 192)),
    object_integer_from(0xFF000000 | RGB(0, 0, 0)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_HIGHLIGHT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_HIGHLIGHTTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_GRAYTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_3DFACE)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_BTNTEXT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_3DHILIGHT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_3DLIGHT)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_3DSHADOW)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_3DDKSHADOW)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_SCROLLBAR)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_INFOBK)),
    object_integer_from(0xFF000000 | GetSysColor(COLOR_INFOBK)),
    0
  };

  return object_list_from(color_list);
}

void invalidate_rect(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  if (hwnd == NULL)
    return;

  InvalidateRect(hwnd, NULL, TRUE);

  object_Dec_ref(handle);
}

void set_colors(cptr fr, cptr fg, cptr fb, cptr br, cptr bg, cptr bb)
{
  fRed = object_as_int(fr);
  fGreen = object_as_int(fg);
  fBlue = object_as_int(fb);

  bRed = object_as_int(br);
  bGreen = object_as_int(bg);
  bBlue = object_as_int(bb);

  object_Dec_ref(fr);
  object_Dec_ref(fg);
  object_Dec_ref(fb);
  object_Dec_ref(br);
  object_Dec_ref(bg);
  object_Dec_ref(bb);
}

void terminate_thread(cptr code)
{
  cint exit_code = object_as_int(code);

  object_Dec_ref(code);

  PostQuitMessage(exit_code);
}

void set_parent(cptr child, cptr parent)
{
  HWND childhwnd = object_as_int(child),
       parenthwnd = (parent != object_Undefined) ? object_as_int(parenthwnd) : NULL;

  SetParent(childhwnd, parenthwnd);
}

cptr get_font_peer(cptr font_string, cptr font_style, cptr font_size)
{
  cstring font = object_as_string(font_string);
  cint style = object_as_int(font_style);
  cint size = object_as_int(font_size);
  HWND hwnd = GetFocus();
  HDC hdc;
  HFONT hfont;

  object_Dec_ref(font_string);
  object_Dec_ref(font_style);
  object_Dec_ref(font_size);

  hdc = GetDC(hwnd);

  hfont = CreateFont(
            -MulDiv(size /*PointSize*/, GetDeviceCaps(hdc, LOGPIXELSY), 72), //lfHeight
            0, // lfWidth 0 - Default
            0, // lfEscapement
            0, // lfOrientation
            (style & 1) ? 700 : 400, // lfWeight 400 - normal, 700 - bold
            (style & 2) ? 1 : 0, //lfItalic
            0, //lfUnderline
            0, //lfStrikeOut
            ANSI_CHARSET, //lfCharSet
            OUT_DEFAULT_PRECIS, //lfOutPrecision
            CLIP_STROKE_PRECIS, //lfClipPrecision
            DEFAULT_QUALITY, //lfQuality
            DEFAULT_PITCH | FF_DONTCARE, //lfPitchAndFamily
            font //lfFaceName
          );

  ReleaseDC(hwnd, hdc);

  mem_free(font);

  return object_integer_from((hfont != NULL) ? hfont : object_Undefined);
}

void set_font(cptr handle, cptr font_handle)
{
  HWND hwnd = object_as_int(handle);
  HFONT hfont = object_as_int(font_handle);
  
  if (hwnd == NULL)
    return;

  if (hfont == NULL)
    return;

  object_Dec_ref(handle);
  object_Dec_ref(font_handle);
  
  SetWindowFont(hwnd, hfont, TRUE);
}

cptr list_getselectedindexes(cptr handle) 
{
  HWND hwnd = object_as_int(handle);
  int numitems = ListBox_GetSelCount(hwnd), i;
  cptr *list, listofitems;

  object_Dec_ref(handle);

  if (hwnd == NULL)
    return object_Undefined;

  list = mem_malloc((numitems+1)*4);
  ListBox_GetSelItems(hwnd, numitems, list);
  for (i = 0; i < numitems; i++)
    list[i] = object_integer_from(list[i]);
  list[numitems] = 0;
  listofitems = object_list_from(list);
  mem_free(list);
  return listofitems;
}

void list_add_string(cptr handle, cptr item_string, cptr index_int)
{
  HWND hwnd = object_as_int(handle);
  cstring item = object_as_string(item_string);
  cint index = object_as_int(index_int);

  object_Dec_ref(handle);
  object_Dec_ref(item_string);
  object_Dec_ref(index_int);

  if (hwnd == NULL)
  {
    mem_free(item);
    return;
  }

  ListBox_InsertString(hwnd, index, item);

  mem_free(item);
}

void delitems(cptr handle, cptr starting, cptr ending)
{
  HWND hwnd = object_as_int(handle);
  cint start = object_as_int(starting),
       end = object_as_int(ending);
  int index;

  object_Dec_ref(handle);
  object_Dec_ref(starting);
  object_Dec_ref(ending);

  if (hwnd == NULL)
    return;

  for (index = start; index <= end; index++)
    ListBox_DeleteString(hwnd, start);
}

void list_removeall(cptr handle)
{
  HWND hwnd = object_as_int(handle);

  object_Dec_ref(handle);

  if (hwnd == NULL)
    return;

  ListBox_ResetContent(hwnd);
}

void list_select(cptr handle, cptr index_int)
{
  HWND hwnd = object_as_int(handle);
  cint index = object_as_int(index_int);

  object_Dec_ref(handle);
  object_Dec_ref(index_int);

  if (hwnd == NULL)
    return;

  ListBox_SetSel(hwnd, TRUE, index);
}

void list_singleselect(cptr handle, cptr index_int)
{
  HWND hwnd = object_as_int(handle);
  cint index = object_as_int(index_int);

  object_Dec_ref(handle);
  object_Dec_ref(index_int);

  if (hwnd == NULL)
    return;

  ListBox_SetCurSel(hwnd, index);
}

void list_deselect(cptr handle, cptr index_int)
{
  HWND hwnd = object_as_int(handle);
  cint index = object_as_int(index_int);

  object_Dec_ref(handle);
  object_Dec_ref(index_int);

  if (hwnd == NULL)
    return;

  ListBox_SetSel(hwnd, FALSE, index);
}

void list_makevisible(cptr handle, cptr index_int)
{
  HWND hwnd = object_as_int(handle);
  cint index = object_as_int(index_int);

  object_Dec_ref(handle);
  object_Dec_ref(index_int);

  if (hwnd == NULL)
    return;

  ListBox_SetCaretIndex(hwnd, index);
}

//remember to dispose of structure

cptr create_filedialog(cptr parent) 
{
  HWND hwnd = (parent != object_Undefined) ? object_as_int(parent) : NULL;
  OPENFILENAME *ofn = mem_malloc(sizeof(OPENFILENAME));
  
  object_Dec_ref(parent);
  
  memset(ofn, 0, sizeof(OPENFILENAME));
  ofn->lStructSize = sizeof(OPENFILENAME);
  ofn->hwndOwner = hwnd;
  ofn->hInstance = hInstance;
  ofn->lpstrFilter = filter;
  ofn->lpstrFile = mem_malloc(256); //buffer for file string.  Remember to free
  ofn->nMaxFile = 256;              
  ofn->lpstrFileTitle = mem_malloc(256); //buffer for file string.  Remember to free
  ofn->nMaxFileTitle = 256;
  ofn->Flags = OFN_HIDEREADONLY | OFN_LONGNAMES;

  return object_integer_from(ofn);
}

cptr filedialog_setvisible(cptr info, cptr mode) 
{
  OPENFILENAME *ofn = object_as_int(info);
  BOOL savemode = (object_as_int(mode) == 1);
  char directory[256], *dir, *file;

  object_Dec_ref(info);
  object_Dec_ref(mode);

  if (ofn == NULL)
    return;
 
  if (savemode)
  {
    ofn->Flags |= OFN_OVERWRITEPROMPT;
    if (!GetSaveFileName(ofn))
    {
      cptr list[] = {object_Undefined, object_Undefined, 0};
      return object_list_from(list);
    }
  }
  else
  {
    if (!GetOpenFileName(ofn))
    {
      cptr list[] = {object_Undefined, object_Undefined, 0};
      return object_list_from(list);
    }
  } 

  strcpy(directory, ofn->lpstrFile);
  directory[strlen(directory)-strlen(ofn->lpstrFileTitle)] = '\0';
  dir = mem_malloc(strlen(directory)+1);
  strcpy(dir, directory);
  file = mem_malloc(strlen(ofn->lpstrFileTitle)+1);
  strcpy(file, ofn->lpstrFileTitle);

  {
    cptr list[] = {object_string_from(dir), object_string_from(file), 0};
    return object_list_from(list);
  } 
}

void set_file(cptr info, cptr name)
{
  OPENFILENAME *ofn = object_as_int(info);
  cstring filename = (name != object_Undefined) ? object_as_string(name) : "";

  object_Dec_ref(info);
  object_Dec_ref(name);
 
  if (ofn == NULL || ofn == object_Undefined)
    return;

  strcpy(ofn->lpstrFile, filename);
  mem_free(filename);
}

void set_directory(cptr info, cptr name) 
{
  OPENFILENAME *ofn = object_as_int(info);
  cstring directory = (name != object_Undefined) ? object_as_string(name) : NULL; //remember to dispose later

  object_Dec_ref(info);
  object_Dec_ref(name);
 
  if (ofn == NULL || name == object_Undefined)
    return;

  ofn->lpstrInitialDir = directory; 
}

void set_filedialog_title(cptr info, cptr name)
{
  OPENFILENAME *ofn = object_as_int(info);
  cstring title = (name != object_Undefined) ? object_as_string(name) : NULL; //remember to dispose;

  object_Dec_ref(name);

  ofn->lpstrTitle = title;
}

cptr getfontmetricsinfo(cptr font_handle)
{  
  HFONT *font = object_as_int(font_handle),
        old_font;
  TEXTMETRIC textmetric;
  HWND hwnd = GetFocus();
  HDC dc = GetDC(hwnd);
  cptr metricsinfo[5];

  object_Dec_ref(font_handle);
  if (font == NULL)
    return object_Undefined;

  old_font = SelectObject(dc, font);
  GetTextMetrics(dc, &textmetric);
  metricsinfo[0] = object_integer_from(textmetric.tmExternalLeading); //FontMetrics.leading 
  metricsinfo[1] = object_integer_from(textmetric.tmAscent); //FontMetrics.ascent
  metricsinfo[2] = object_integer_from(textmetric.tmDescent); //FontMetrics.descent
  metricsinfo[3] = object_integer_from(textmetric.tmMaxCharWidth); //FontMetrics.maxadvance
  metricsinfo[4] = 0;
  SelectObject(dc, old_font);
  ReleaseDC(hwnd, dc);
  return object_list_from(metricsinfo);
}

cptr string_width(cptr font_handle, cptr string)
{
  HWND hwnd = GetFocus();
  HDC dc = GetDC(hwnd);
  SIZE size;
  char *s = object_as_string(string);
  int string_length;
  HFONT old_font,
        font = object_as_int(font_handle);

  object_Dec_ref(font_handle);
  object_Dec_ref(string);

  if (font == NULL)
    return object_Undefined;

  old_font = SelectObject(dc, font);

  string_length = strlen(s);

  GetTextExtentPoint32(dc, s, string_length, &size);

  SelectObject(dc, old_font);
  ReleaseDC(hwnd, dc);

  mem_free(s);

  return object_integer_from(size.cx);
}

cptr char_widths(cptr font_handle)
{
  HWND hwnd = GetFocus();
  HDC dc = GetDC(hwnd);
  SIZE size;
  char s[2] = "\0\0";
  HFONT old_font,
        font = object_as_int(font_handle);
  cptr charwidths[257];
  int i;

  object_Dec_ref(font_handle);

  if (font == NULL)
    return object_Undefined;

  old_font = SelectObject(dc, font);

  for (i = 0; i < 256; i++)
  {
    s[0] = i;
    GetTextExtentPoint32(dc, s, 2, &size);
    charwidths[i] = object_integer_from(size.cx);
  }
  charwidths[256] = 0;

  SelectObject(dc, old_font);
  ReleaseDC(hwnd, dc);

  return object_list_from(charwidths);
}

cptr get_textfield_preferredsize(cptr handle, cptr cols)
{
  HWND hwnd = object_as_int(handle);
  HDC dc;
  HFONT old_hfont;
  TEXTMETRIC textmetric;
  cint columns = object_as_int(cols);

  object_Dec_ref(handle);
  object_Dec_ref(cols);
  
  if (hwnd == NULL)
    return;

  dc = GetDC(hwnd);
  old_hfont = SelectObject(dc, GetWindowFont(hwnd));
  GetTextMetrics(dc, &textmetric);

  SelectObject(dc, old_hfont);
  ReleaseDC(hwnd, dc);

  {
    cptr width_and_height[] = {object_integer_from(12+textmetric.tmAveCharWidth*columns+12), 
                               object_integer_from(4+textmetric.tmHeight+4), 0};
    return object_list_from(width_and_height);
  }
}

cptr get_textarea_preferredsize(cptr handle, cptr r, cptr cols)
{
  HWND hwnd = object_as_int(handle);
  HDC dc;
  HFONT old_hfont;
  TEXTMETRIC textmetric;
  cint rows = object_as_int(r),
       columns = object_as_int(cols);

  object_Dec_ref(handle);
  object_Dec_ref(r);
  object_Dec_ref(cols);
  
  if (hwnd == NULL)
    return;

  dc = GetDC(hwnd);
  old_hfont = SelectObject(dc, GetWindowFont(hwnd));
  GetTextMetrics(dc, &textmetric);

  SelectObject(dc, old_hfont);
  ReleaseDC(hwnd, dc);

  {
    cptr width_and_height[] = {object_integer_from(12+textmetric.tmAveCharWidth*columns+12), 
                               object_integer_from(4+textmetric.tmHeight*rows+4), 0};
    return object_list_from(width_and_height);
  }
}

cptr get_list_preferred_size(cptr handle, cptr r)
{
  HWND hwnd = object_as_int(handle);
  HDC dc;
  SIZE size;
  char *s;
  int string_length, i, numitems, maxlength = 0, maxheight = 0;
  HFONT old_hfont;
  TEXTMETRIC textmetric;
  cint rows = object_as_int(r);

  object_Dec_ref(r);
  object_Dec_ref(handle);
  
  if (hwnd == NULL)
    return;

  dc = GetDC(hwnd);
  old_hfont = SelectObject(dc, GetWindowFont(hwnd));
  GetTextMetrics(dc, &textmetric);

  SelectObject(dc, old_hfont);
  ReleaseDC(hwnd, dc);
  
  {
    cptr width_and_height[] = {object_integer_from(2+textmetric.tmAveCharWidth*8+2), 
                               object_integer_from(2+textmetric.tmHeight*rows+2), 0};
    return object_list_from(width_and_height);
  }
}

void doModal(cptr handle)
{
  HWND hwnd = (handle != object_Undefined) ? object_as_int(handle) : NULL;
  UINT loopdialogID = ++modaldialogsrunning;
  MSG msg;

  if (hwnd == NULL)
    return;

  while (GetMessage(&msg, NULL, 0, 0 )) 
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
    if (loopdialogID != modaldialogsrunning)
      return;
  }
}

void beep()
{
  MessageBeep(-1);
}

cptr get_screen_size()
{
  cptr width = object_integer_from(GetSystemMetrics(SM_CXSCREEN)),
       height = object_integer_from(GetSystemMetrics(SM_CYSCREEN));

  {
    cptr dimension[] = {width, height, 0};
    return object_list_from(dimension);
  }
}

cptr get_screen_resolution() 
{
  HWND hwnd = GetFocus();
  HDC dc = GetDC(hwnd);
  int resolution = GetDeviceCaps(dc, LOGPIXELSX);

  ReleaseDC(hwnd, dc);

  return object_integer_from(resolution);
}
