#ifndef SLIMAWT_H
#define SLIMAWT_H

#include <windows.h>
#include "cdefs.h"

//initialize stuff
BOOL awt_initialize();

//event stuff
LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK PanelProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ButtonProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CheckboxProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ChoiceProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK LabelProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK TextProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ScrollbarProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ListProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);

void OnCommand(HWND hwnd, int ID, HWND hwndCtl, UINT codeNotify);
void OnPaint(HWND hwnd);
void OnMove(HWND hwnd, int x, int y);
void OnDFSize(HWND hwnd, UINT nType, int cx, int cy);
void OnSize(HWND hwnd, UINT nType, int cx, int cy);
void OnShowWindow(HWND hwnd, BOOL bShow, UINT nStatus);
void OnCaptureChanged(HWND hwnd, HWND other_hwnd);
UINT convert_key(UINT nVirtKey);
UINT key_code(UINT nVirtKey);
void OnKey(HWND hwnd, UINT nVirtKey, BOOL fDown, int cRepeat, UINT nFlags);
void OnSystemKey(HWND hwnd, UINT nVirtKey, BOOL fDown, int cRepeat, UINT nFlags);
void OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags);
void OnMButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags);
void OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int pointx, int pointy, UINT nFlags);
void OnLButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags);
void OnMButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags);
void OnRButtonUp(HWND hwnd, int pointx, int pointy, UINT nFlags);
void OnMouseMove(HWND hwnd, UINT nFlags, int x, int y);
void OnSetFocus(HWND hwnd, HWND hwndLoseFocus);
void OnKillFocus(HWND hwnd, HWND hwndGetFocus);
void OnClose(HWND hwnd);
void OnVScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos);
void OnHScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos);
void OnGotFocus(HWND hwnd, UINT fActive, HWND tempwnd, BOOL fMinimized);
BOOL OnSetCursor(HWND hwnd, HWND which_hwnd, int nHitTest, int wMouseMsg);

//component stuff
void show_window(cptr handle, cptr width_val, cptr height_val);
void hide_window(cptr handle);
void enable_window(cptr handle);
void disable_window(cptr handle);
void move_window(cptr handle, cptr x_val, cptr y_val, cptr width_val, cptr height_val);
cptr get_location_on_screen(cptr handle);
void set_cursor(cptr handle, cptr cursor);
HBRUSH OnCtlColorBtn(HWND hwnd, HDC dc, HWND hwndbutton);
HBRUSH OnCtlColorStatic(HWND hwnd, HDC dc, HWND hwndstatic);
HBRUSH OnCtlColorEdit(HWND hwnd, HDC dc, HWND hwndedit);
HBRUSH OnCtlColorScrollbar(HWND hwnd, HDC dc, HWND hwndscrollbar);
HBRUSH OnCtlColorListbox(HWND hwnd, HDC dc, HWND hwndlistbox);
HBRUSH OnCtlColorChoiceListbox(HWND hwnd, HDC dc, HWND hwndlistbox);
void request_focus(cptr handle);
cptr get_component_preferred_size(cptr handle);
void enable_events(cptr objectID, cptr object, cptr events);
void dispose_component(cptr handle);

//container stuff
cptr get_insets(cptr handle);
void move_container_window(cptr handle, cptr x_val, cptr y_val, cptr width_val, cptr height_val);

//window stuff
void to_front(cptr handle);
void to_back(cptr handle);

//frame stuff and dialog stuff
cptr create_frame();
void set_title(cptr handle, cptr title);
cptr create_dialog(cptr parent);
void enable_sizable(cptr handle);
void disable_sizable(cptr handle);

//label stuff
cptr create_label(cptr parent);
void set_left_alignment(cptr label);
void set_center_alignment(cptr label);
void set_right_alignment(cptr label);

//button stuff
cptr create_button(cptr parent);

//checkbox stuff and list stuff
cptr create_checkbox(cptr parent);
void check_checkbox(cptr checkbox);
void uncheck_checkbox(cptr checkbox);

//choice stuff
cptr create_choice(cptr parent);
void add_choice_string(cptr choice, cptr string, cptr index);
void remove_choice_string(cptr choice, cptr index);
void select_choice_string(cptr choice, cptr index);
void morph_into_radiobutton(cptr handle);
void morph_into_checkbox(cptr handle);
cptr get_choice_preferred_size(cptr handle);

//list stuff
cptr create_list(cptr parent);

//TextComponent stuff
void set_editable(cptr handle, cptr editable);
cptr get_text(cptr handle);
void set_text(cptr handle, cptr string);
cptr get_selection_start(cptr handle);
cptr get_selection_end(cptr handle);
void text_component_select(cptr handle, cptr start, cptr end);

//TextField stuff
cptr create_textfield(cptr parent);
void set_echo_char(cptr handle, cptr character);

//TextArea stuff
cptr create_textarea(cptr parent, cptr scrollbar_visibility);
void replace_range(cptr handle, cptr string);

//Scrollbar stuff
cptr create_scrollbar(cptr parent, cptr orientation);
void set_values(cptr handle, cptr val, cptr vis, cptr min, cptr max);

//generic stuff
void set_component_label(cptr component, cptr title);

//Font stuff
cptr get_font_list();

//bitwise utilities
cint and_bits(cptr num1, cptr num2);
cint or_bits(cptr num1, cptr num2);
cint not_bits(cptr num1);
cint xor_bits(cptr num1, cptr num2);

//Mouse hook to get all mouse events
LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam);
double get_time();
void inc_move_counter();
void inc_size_counter();

//Other toolkit stuff
cptr load_system_colors();

//Misc stuff
void invalidate_rect(cptr handle);
void set_colors(cptr fr, cptr fg, cptr fb, cptr br, cptr bg, cptr bb);
void terminate_thread(cptr code);

#endif
